<template lang="pug">

  .container(v-loading="pageLoading")
    .activity__block(v-if='updatedAdmin')
      p.create-date-lable Обновлено {{ updatedAdmin }}
    .block-typical

      el-form.flex-form(
        ref='adminForm'
        v-if="inputs.length"
        :model='stateForm'
        :rules="rules")

        el-form-item(
          v-for="item in inputs"
          :key="item.id"
          :style="item.maxWidth ? `max-width:${item.maxWidth}px; margin-bottom: 35px` : 'margin-bottom: 35px'"
          :prop="item.name")

          app-input(
            :placeholder="item.placeholder"
            :model="modelInput(item.name)"
            :name="item.name"
            :id="item.id"
            :label="item.label"
            :type="item.type"
            :prompt="item.prompt"
            :autosize="item.autosize"
            :maxlength="item.maxlength"
            :required="item.required"
            @input-value="modelValue")

      el-checkbox(v-model="adminRoleDelete") Снять права администратора

    .activity__block.reverse
      .activity__block-wrapper
        h5 Активность:
        el-switch(
          v-model='admin.active'
          active-color="#39D24E"
          :active-value='true'
          :inactive-value='false')

    .activity__block
      router-link.el-button.el-button--info.button(
      :to="{path: '/admin/admins'}")
        |Отмена

      el-button.button(
      type="success"
      @click="updateAdmin('adminForm')")
        |Сохранить изменения

</template>

<script>
import InputItem from '../../../components/InputItem';

export default {
  layout: 'admin',
  name: 'AdminsIem',
  components: {
    'app-input': InputItem
  },
  async asyncData(context) {
    let { data } = await context.$axios.get(
      `/api/v1/users/${context.params.id}`
    );
    return { admin: data };
  },
  data() {
    return {
      inputs: [
        {
          id: 1,
          placeholder: 'Укажите фамилию администратора',
          model: '',
          label: 'Фамилия',
          name: 'lastName'
        },
        {
          id: 2,
          placeholder: 'Укажите имя администратора',
          model: '',
          label: 'Имя',
          name: 'firstName'
        },
        {
          id: 3,
          placeholder: 'Укажите отчество администратора',
          model: '',
          label: 'Отчество',
          name: 'middleName'
        },
        {
          id: 4,
          placeholder: 'Укажите email пользователя',
          model: '',
          label: 'Email',
          name: 'email',
          required: true,
          prop: [
            {
              required: true,
              message: 'Пожалуйста, введите email',
              trigger: 'change'
            },
            {
              type: 'email',
              message: 'Пожалуйста, укажите верный email',
              trigger: 'change'
            }
          ]
        },
        {
          id: 5,
          placeholder: '+7 (999) 999 99 99',
          model: '',
          label: 'Телефон',
          type: 'phone',
          name: 'phone'
        },
        {
          id: 6,
          placeholder: 'Введите пароль',
          model: '',
          label: 'Пароль',
          name: 'password',
          type: 'password',
          required: true,
          prop: [
            {
              required: true,
              message: 'Пожалуйста, укажите пароль',
              trigger: 'change'
            },
            {
              min: 6,
              message: 'Пароль не менее 6-ти симмволов',
              trigger: 'change'
            }
          ]
        }
      ],
      adminRoleDelete: false,
      password: '',
      pageLoading: false,
      updatedAdmin: null
    };
  },
  computed: {
    stateForm() {
      let state = {};
      this.inputs.forEach(item => {
        if (item.name !== 'password' && item.name !== 'oldPassword') {
          state[item.name] = this.admin[item.name];
        }
      });
      state.password = this.password;
      return state;
    },
    rules() {
      let rulesObj = {};
      this.inputs.forEach(item => {
        rulesObj[item.name] = item.prop;
      });
      return rulesObj;
    }
  },
  created() {
    this.$store.commit('pages', [
      {
        name: 'Администраторы',
        slug: '/admin/admins'
      }
    ]);
    this.$store.commit('headingTitle', 'Администратор');
    this.$store.commit('publicLink', '');
    this.$store.commit('id', this.admin.id);
  },
  mounted() {
    this.inputs.forEach(item => {
      item.model = this.admin[item.name];
    });
    if (this.admin.updated_at) {
      this.updatedAdmin = `${this.$moment(this.admin.updated_at).format(
        'D.MM.YY'
      )}, в ${this.$moment(this.admin.updated_at).format('H:mm')}`;
    }
  },
  methods: {
    modelInput(name) {
      if (name === 'password') {
        return this.password;
      } else {
        return this.stateForm[name];
      }
    },
    modelValue(valueArr) {
      let index = this.inputs.findIndex(item => item.id === valueArr[0]);
      let name = this.inputs[index].name;
      if (name === 'password') {
        this.password = valueArr[1];
      } else {
        this.admin[name] = valueArr[1];
      }
    },
    updateAdmin(formName) {
      this.$refs[formName].validate(valid => {
        if (valid) {
          this.pageLoading = true;
          let patchState = {
            firstName: this.stateForm.firstName,
            lastName: this.stateForm.lastName,
            middleName: this.stateForm.middleName,
            email: this.stateForm.email,
            password: this.stateForm.password,
            phone: this.stateForm.phone,
            active: this.admin.active
          };
          if (this.adminRoleDelete) {
            patchState.role = 'user';
          }
          this.$axios
            .patch(`/api/v1/users/${this.$route.params.id}`, patchState)
            .then(
              () => {
                this.pageLoading = false;
                this.$message.success(
                  'Данные администратора успешно изменены!'
                );
                if (this.adminRoleDelete) {
                  this.$router.push(`/admin/users/${this.$route.params.id}`);
                }
              },
              errorMessage => {
                console.log(errorMessage);
                this.$message.error('Ошибка перезаписи данных!');
                this.pageLoading = false;
              }
            )
            .catch(() => {
              this.$message.error('Ошибка перезаписи данных');
              this.pageLoading = false;
            });
        } else {
          this.$message.error('Пожалуйста, заполните все обязательные поля!');
          return false;
        }
      });
    }
  }
};
</script>
